summaryrefslogtreecommitdiffstats
path: root/libraries/wxWidgets/wxWidgets.SlackBuild
diff options
context:
space:
mode:
Diffstat (limited to 'libraries/wxWidgets/wxWidgets.SlackBuild')
-rw-r--r--libraries/wxWidgets/wxWidgets.SlackBuild208
1 files changed, 208 insertions, 0 deletions
diff --git a/libraries/wxWidgets/wxWidgets.SlackBuild b/libraries/wxWidgets/wxWidgets.SlackBuild
new file mode 100644
index 0000000000..10ce6f60bb
--- /dev/null
+++ b/libraries/wxWidgets/wxWidgets.SlackBuild
@@ -0,0 +1,208 @@
+#!/bin/bash
+
+# Slackware build script for wxWidgets
+
+# Copyright 2023 Willy Sudiarto Raharjo <willysr@slackbuilds.org>
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ''AS IS'' AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+cd $(dirname $0) ; CWD=$(pwd)
+
+PRGNAM=wxWidgets
+VERSION=${VERSION:-3.2.4.1}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+PKGTYPE=${PKGTYPE:-tgz}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+if [ ! -z "${PRINT_PACKAGE_NAME}" ]; then
+ echo "$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE"
+ exit 0
+fi
+
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+# Check for STL
+if [ "${STL:-no}" = "yes" ]; then
+ stl="ON"
+else
+ stl="OFF"
+fi
+
+# Check for WebKit
+webkit=`pkg-config --exists webkit2gtk-4.0`
+if [ "$?" -eq 0 ]; then
+ wk="ON"
+else
+ wk="OFF"
+fi
+
+# BCS: check for NanoSVG
+test -f /usr/include/nanosvg/nanosvg.h
+case "${NANOSVG:-auto}" in
+ no|off) nanosvg=OFF ;;
+ yes|on) [ $? = 0 ] && nanosvg=sys || nanosvg=builtin ;;
+ auto) [ $? = 0 ] && nanosvg=sys || nanosvg=OFF ;;
+ internal) nanosvg=builtin ;;
+esac
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $PRGNAM-$VERSION
+tar xvf $CWD/$PRGNAM-$VERSION.tar.gz
+cd $PRGNAM-$VERSION
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \+ -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \+
+
+sed -i "s|prefix}/lib|prefix}/lib$LIBDIRSUFFIX|" build/cmake/config.cmake
+
+if [ -z "$INTERFACE" ]; then
+cmake -B build-gtk3 \
+ -DCMAKE_C_FLAGS:STRING="$SLKCFLAGS" \
+ -DCMAKE_CXX_FLAGS:STRING="$SLKCFLAGS" \
+ -DCMAKE_INSTALL_PREFIX=/usr \
+ -DwxBUILD_TOOLKIT=gtk3 \
+ -DwxUSE_OPENGL=ON \
+ -DwxUSE_REGEX=sys\
+ -DwxUSE_ZLIB=sys \
+ -DwxUSE_EXPAT=sys \
+ -DwxUSE_LIBJPEG=sys \
+ -DwxUSE_LIBPNG=sys \
+ -DwxUSE_LIBTIFF=sys \
+ -DwxUSE_LIBLZMA=sys \
+ -DwxUSE_LIBMSPACK=ON \
+ -DwxUSE_NANOSVG=$nanosvg \
+ -DwxUSE_STL=$stl \
+ -DwxUSE_WEBVIEW_WEBKIT=$wk \
+ -DwxUSE_PRIVATE_FONTS=ON \
+ -DCMAKE_BUILD_TYPE=Release .
+cmake --build build-gtk3
+DESTDIR="$PKG" cmake --install build-gtk3
+
+elif [ "${INTERFACE:-gtk3}" = "qt" ]; then
+cmake -B build-qt5 \
+ -DCMAKE_C_FLAGS:STRING="$SLKCFLAGS" \
+ -DCMAKE_CXX_FLAGS:STRING="$SLKCFLAGS" \
+ -DCMAKE_INSTALL_PREFIX=/usr \
+ -DwxBUILD_TOOLKIT=qt \
+ -DwxUSE_OPENGL=ON \
+ -DwxUSE_REGEX=sys\
+ -DwxUSE_ZLIB=sys \
+ -DwxUSE_EXPAT=sys \
+ -DwxUSE_LIBJPEG=sys \
+ -DwxUSE_LIBPNG=sys \
+ -DwxUSE_LIBTIFF=sys \
+ -DwxUSE_LIBLZMA=sys \
+ -DwxUSE_LIBMSPACK=ON \
+ -DwxUSE_NANOSVG=OFF \
+ -DwxUSE_STL=$stl \
+ -DwxUSE_WEBVIEW_WEBKIT=$wk \
+ -DwxUSE_PRIVATE_FONTS=ON \
+ -DCMAKE_BUILD_TYPE=Release .
+cmake --build build-qt5
+DESTDIR="$PKG" cmake --install build-qt5
+fi
+
+#Move librarys to their correct location and fix pkgconfig
+if [ "$LIBDIRSUFFIX" != "" ]; then
+ mv $PKG/usr/lib $PKG/usr/lib${LIBDIRSUFFIX}
+ sed -i "s/\/lib\//\/lib${LIBDIRSUFFIX}\//g" \
+ $PKG/usr/lib${LIBDIRSUFFIX}/cmake/$PRGNAM/${PRGNAM}Config.cmake
+ sed -i "s/\/lib\//\/lib${LIBDIRSUFFIX}\//g" \
+ $PKG/usr/lib${LIBDIRSUFFIX}/cmake/$PRGNAM/${PRGNAM}Targets.cmake
+ sed -i "s/\/lib\//\/lib${LIBDIRSUFFIX}\//g" \
+ $PKG/usr/lib${LIBDIRSUFFIX}/cmake/$PRGNAM/${PRGNAM}Targets-release.cmake
+fi
+
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+install -Dm644 wxwin.m4 -t $PKG/usr/share/aclocal
+
+# wxWidgets 3.2 provides 2 wx-configs, but we will use GTK by default
+gtk=gtk3-unicode-3.2
+qt=qt-unicode-3.2
+
+if [ "${INTERFACE:-gtk3}" = "qt" ]; then
+ ln -sf ../lib${LIBDIRSUFFIX}/wx/config/$qt $PKG/usr/bin/wx-config
+else
+ ln -sf ../lib${LIBDIRSUFFIX}/wx/config/$gtk $PKG/usr/bin/wx-config
+fi
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+
+# 20220414 bkw: instead of installing the *source* to the doxygen docs,
+# actually run doxygen and install the generated HTML docs.
+# This is only done if the users asks for it.
+# The "|| true" stuff is meant to keep errors in the documentation from
+# killing the build. DOT_NUM_THREADS=1 may slow things down a bit on
+# well-endowed hosts, but it prevents running out of memory on lesser ones.
+# Don't try to generate the API docs if graphviz is missing.
+if [ "${APIDOC:-no}" = "yes" ] && which dot &> /dev/null; then
+ echo "=== APIDOC=yes and graphviz exists, building API docs"
+ cd docs/doxygen
+ echo 'DOT_NUM_THREADS = 1' >> Doxyfile
+ GENERATE_LATEX=NO doxygen || true
+ mv out/html $PKG/usr/doc/$PRGNAM-$VERSION/api || true
+ cd -
+else
+ echo "=== not building API docs"
+fi
+rm -rf docs/doxygen
+
+cp -a docs/* $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+rm -f $PKG/usr/lib${LIBDIRSUFFIX}/*.la
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE